	def httpPOST(self,data,return_data=False,ping=False):
		if ping==False:
			self.Debug(b"httpPOST")
			if not data:
				return False
			
			if self.network_on==False or self.http_fail_count>0:
				return False
		else:
			self.Debug(b"httpPOST:Ping")
			
		res=True
		http=None
		
		port=9000
		
		# - DNS loopup -
		self.Debug(b"DNS lookup")
		try:
			address=usocket.getaddrinfo(self.conf["gw"], port)[0][-1]
			self.Debug("{} -> {}".format(self.conf["gw"],address))
		except:
			self.Debug(b"DNS lookup failed!")
			res=False
		
		# - Create socket -
		if res==True:
			try:
				http=usocket.socket(usocket.AF_INET, usocket.SOCK_STREAM, usocket.IPPROTO_TCP)
			except Exception as e:
				self.Debug(b"Failed to create http socket! {}".format(e))
				res=False
		
		# - Set non-blocking socket -
		if res==True:
			self.Debug(b"Set non-blocking")
			try:
				http.setblocking(False)
			except:
				self.Debug(b"Failed to set non-blocking)!")
				res=False
		
		# -- Poll process --
		if res==True and address:
			self.Debug(b"Create poll")
			p = uselect.poll()
			
			self.Debug(b"Register poll")
			try:
				p.register(http, uselect.POLLIN | uselect.POLLOUT | uselect.POLLHUP | uselect.POLLERR)
			except:
				res=False
			
			if res==True:
				self.Debug(b"Connect")
				try:
					http.connect(address)
				except OSError as e:
					# In case of non-blocking socket the connect() raises eception of EINPROGRESS what is expected
					if e.args[0] != 119:
						res=False
						self.Debug(b"HTTP connect to server failed!")
			
			if res==True:
				self.Debug(b"Connected to server")
				
			ts=utime.time()
			run_loop=True
			while run_loop:
				list=p.poll()
				for t in list:
					event=t[1]
					
					# - Error handing -
					if event & uselect.POLLERR or event & uselect.POLLHUP:
						self.Debug("HTTP sock error")
						res=False
						run_loop=False
						break
						
					# - Output data -
					elif event & uselect.POLLOUT:
						if ping:
							self.Debug(b"Ping success")
							run_loop=False
							break
					
						http.write(b"POST / HTTP/1.0\r\n")
						http.write(b"Host: %s\r\n" % self.conf["gw"])
						http.write(b"User-Agent: WiPy\r\n")
						http.write(b"Content-Type: application/json\r\n")
						http.write(b"Content-Length: %d\r\n" % len(data))
						http.write(b"\r\n")
						http.write( data )
						
						self.Debug("POST Data success:\n{}".format(data))
						
						p.modify(http, uselect.POLLIN | uselect.POLLHUP | uselect.POLLERR)
					
					# - Input data -
					elif event & uselect.POLLIN:
						if ping:
							run_loop=False
							break
						
						response=http.readline()
						status=0;
						if response:
							if type(response) == bytes:
								response=response.decode("utf-8")
								
							self.Debug("POST response:\n{}".format(response));
							protover, status, msg = response.split(None, 2)
						status = int(status)
						del(response)
						
						if not 200 <= status <= 299:
							print("HTTP Error code: {}".format(status))
							res=False
							break
						else:
							if return_data==True:
								self.cmd=b""
								in_data=False
								while True:
									response=http.readline()
									if response==None:
										break
									
									if in_data==True:
										self.cmd+=response
									elif self.regex_empy_newline.match( response ):
										in_data=True
									
									del(response)
							else:
								self.cmd="";
								while True:
									self.cmd = http.readline()
									# Decode to string
									if type(self.cmd) == bytes:
										self.cmd=self.cmd.decode("utf-8")
										
									if not self.cmd or len(self.cmd) == 0:
										break
									elif self.regex_cmd_got.match(self.cmd):
										self.ProcCMD()
										break
								
								
						
						run_loop=False
						break
							
							
				# - Time-out after 10 sec -
				if run_loop and ts+10 < utime.time():
					self.Debug("Connection time-out")
					res=False
					break
						
			
			# - Disconnect and close socket/poll -
			try:
				p.unregister(http)
			except:
				pass
			
			try:
				http.close()
			except:
				pass
			
			del(http)
			gc.collect()
			
			return res